class LogType {
  static const String INFO_ALL = '-1';
  static const String API_RESPONSE = '1';
  static const String INFO = '2';
  static const String ERROR = '4';
  static const String PROMISE_ERROR = '8';
  static const String AJAX_ERROR = '16';
  static const String SCRIPT_ERROR = '32';
  static const String IMAGE_ERROR = '64';
  static const String CSS_ERROR = '128';
  static const String CONSOLE_ERROR = '256';
  static const String MEDIA_ERROR = '512';
  static const String RET_ERROR = '1024';
  static const String REPORT = '2048';
}

/// 平台类型
enum PlatTypeNum {
  unknown,
  android,
  ios,
  windows,
  macos,
  linux,
  devtools,
  other,
}

/// 网络类型
enum NetworkTypeNum {
  unknown,
  wifi,
  net2g,
  net3g,
  net4g,
  net5g,
  net6g,
}

const int networkTypeOther = 100;

/// 日志类型
class NormalLog {
  dynamic msg;
  String level;
  NormalLog({required this.msg, required this.level});
  Map toJson() => {
        'msg': msg,
        'level': level,
      };
}

class EventLog {
  String name;
  String? ext1;
  String? ext2;
  String? ext3;
  String? from;
  EventLog({
    required this.name,
    this.ext1,
    this.ext2,
    this.ext3,
    this.from,
  });
}

class ReportTimeLog {
  String name;
  int duration;
  String? ext1;
  String? ext2;
  String? ext3;
  String? from;
  ReportTimeLog({
    required this.name,
    required this.duration,
    this.ext1,
    this.ext2,
    this.ext3,
    this.from,
  });
  Map toJson() => {
        'name': name,
        'duration': duration,
        'ext1': ext1 ?? '',
        'ext2': ext2 ?? '',
        'ext3': ext3 ?? '',
        'from': from ?? '',
      };
}
