import '../core.dart';
import '../model/log.dart';
import 'index.dart';

/// 限制error重复上报次数
NormalLogPipe createErrorLogLimitPipe(Core aegis) {
  Map<dynamic, int> logMap = {};
  return (List<NormalLog> logs, Resolve resolve) {
    int maxNum = aegis.config.repeat;
    if (maxNum == 0) {
      resolve(logs);
      return;
    }
    List<NormalLog> dedupLogs = logs.where((log) {
      if (log.level == LogType.ERROR ||
          log.level == LogType.PROMISE_ERROR ||
          log.level == LogType.AJAX_ERROR ||
          log.level == LogType.SCRIPT_ERROR ||
          log.level == LogType.IMAGE_ERROR ||
          log.level == LogType.CSS_ERROR ||
          log.level == LogType.MEDIA_ERROR) {
        logMap[log.msg] = logMap[log.msg] ?? 0;
        logMap[log.msg] = logMap[log.msg]! + 1;
        if (logMap[log.msg]! > maxNum) {
          return false;
        }
        return true;
      }
      return true;
    }).toList();
    resolve(dedupLogs);
  };
}
