import '../core.dart';
import '../model/log.dart';
import '../model/options.dart';
import 'index.dart';

/// 普通日志最终的上报管道
NormalLogPipe createReportPipe(Core aegis) {
  return (List<NormalLog> msgs, Resolve resolve) {
    aegis.send(
      options: Options(
        url: aegis.config.url,
        type: SendType.log,
        data: buildLogParams(msgs),
        method: Method.POST,
        contentType: 'application/x-www-form-urlencoded',
      ),
    );
  };
}

String buildLogParams(List<NormalLog> logs) {
  String output = '';
  if (logs.length == 0) {
    return output;
  }
  for (int i = 0; i < logs.length; i++) {
    NormalLog log = logs[i];
    output = output +
        'msg[$i]=${Uri.encodeComponent(log.msg)}&level[$i]=${log.level}&';
  }
  output = output + 'count=${logs.length}';
  return output;
}
